module Main.Types
  ( ArithOp (..),
    EqOp (..),
    OrdCmpOp (..),
    -- BinExpr (..),
    Int (..),
    Bool (..),
    Statement (..),
  )
where

import qualified Prelude as P

data ArithOp = Add | Sub | Mul | Div deriving (P.Show)

data EqOp = EQ | NE deriving (P.Show)

data OrdCmpOp = GT | GTE | LT | LTE deriving (P.Show)

-- newtype BinExpr op i o = BinExpr (op -> i -> i -> o)

data Int
  = Int P.Int
  | IntArith ArithOp Int Int -- (BinExpr ArithOp Int Int)
  deriving (P.Show)

data Bool
  = Bool P.Bool
  | IntEq EqOp Int Int -- (BinExpr EqOp Int Bool)
  | IntOrdCmp OrdCmpOp Int Int -- (BinExpr OrdCmpOp Int Bool)
  | BoolEq EqOp Bool Bool -- (BinExpr EqOp Bool Bool)
  deriving (P.Show)

data Statement
  = PrintInt Int
  | PrintBool Bool
  deriving (P.Show)